<template>
  <div class="box">
    <div  v-show="home" class="home" >
      <section class="wrapper inner wrapper--flex">
      <div class="flex_b">
        <section class="mb mb--flex sec_fullPage">
          <div class="mb_card">
            <!---->
            <!-- 替換用的卡片樣式-->
            <div class="mb_card_box" :style="{'width':client + 'px'}">
              <img :src="'./static/images/card/platinum.png'" alt="白金卡" v-if="platinum">
              <img :src="'./static/images/card/friend.png'" alt="普卡" v-if="friend">
              <img :src="'./static/images/card/gold.png'" alt="金卡" v-if="gold">
              <img :src="'./static/images/card/diamond.png'" alt="钻石卡" v-if="diamond">
            </div>
            <!---->
            <!-- 會員資料-->
            <!-- ".member--forFriend" 普卡專用白字請加在此-->
            <section class="member" :style="{color:friend?'#fff':'#000'}">
              <div>
                <!---->
                <!--會員卡片類別-->
                <h2 class="mb_card_typeEN">{{rankName}}</h2>
                <h4 class="mb_card_typeCN">{{cardName}}</h4>
              </div>
              <div>
                <!---->
                <!--會員名稱及累積方法-->
                <h3 class="mb_card_mb">{{contactName}}</h3>
                <p class="mb_card_points">消费1元，得{{records}}积分</p>
              </div>
            </section>
          </div>
          <!---->
          <!-- bar code 及序號 替換-->
          <div class="space">
            <div class="bar_code" >
              <svg id="barcode" ></svg>
            </div>
            <!--<img class="bar_code" :src="'./static/images/barcode.png'">-->
            <!--<p class="bar_code_number">{{barcode}}</p>-->
            <!--<div @click="barcode">生成一维码</div>-->

          </div>
          <!---->
          <!-- 對應卡片的類別替換style內的background-color-->
          <!-- ".member--forFriend" 普卡專用白字請加在此 -->
          <div class="space card_remind" style="background-color: #CED0D2">
            <!-- 計時器-->
            <time style="display: flex;">
              00:{{minutes}}:{{seconds}}
              </time>
            <span>购物时请出示此码累积消费与积分</span>
          </div>
        </section>
        <section class="mb mb_point" style="display:flex">
          <!---->
          <!--會員有效點數-->
          <div class="mb_point_effective">
            <span class="mb_point_item">有效积分</span>
            <span class="mb_point_data" style="margin-top: 0.2rem;">{{pointCount}}</span>
          </div>
          <!---->
          <!--會員近3個月到期點數-->
          <div class="mb_point_expire">
            <span class="mb_point_item">近3个月到期积分</span><span class="mb_point_data" style="margin-top: 0.2rem;">{{expirePoints}}</span>
          </div>
        </section>
      </div>
      <div class="flex_b">
        <!---->
        <!--至其他頁面的連結-->
        <!--href="mycount2.html"-->
        <!--href="../memberRights/benefits.html"-->
        <!--href="../expenseDetail/sales.html"-->
        <!--href="../integralRecord/point.html"-->
        <section class="mb_link">
            <a class="mb_link_item" id="mycount" @click="mycount" :class="{'active':clientHeight<600}">
              <div class="mb_link_item-img mb_link-icon01"></div>
              <span>个人信息</span>
          </a>
          <a class="mb_link_item"  id="benefits" @click="benefits" :class="{'active':clientHeight<600}">
              <div class="mb_link_item-img mb_link-icon02"></div>
              <span>会员权益</span>
          </a>
            <a class="mb_link_item"  id="expense" @click="expense" :class="{'active':clientHeight<600}">
            <div class="mb_link_item-img mb_link-icon03"></div>
            <span>消费明细</span>
          </a>
          <a class="mb_link_item"  id="record" @click="record" :class="{'active':clientHeight<600}">
            <div class="mb_link_item-img mb_link-icon04"></div>
            <span>积分记录</span>
          </a>
        </section>
      </div>
    </section>
    </div>
    <!--弹窗-->
    <section class="pop" style ="display: block;" v-if="popshow">
      <section class="pop_content">
        <div class="pop_close" @click="close"><span></span><span></span></div>
        <div id="content">
          <div v-show="isThirdError ">
            <div class="confirmInfo mgt_24">
              <span class="confirmNum"></span><strong></strong></div>
            <div class="confirmInfo mgt_12 mgb_24">
              <span class="confirmName"></span><strong></strong></div>
            <div class="pop_info">
              <p>抱歉由于简讯验证码输入错误达3次以上，您的注册功能已被暂时锁定。
                并将于[<span>{{newtime}}</span>]解除锁定
                如您有需要协助之处，请点选菜单上的在线客服，谢谢。
              </p>
            </div>
          </div>
          <div v-show="!isType && isContact ">
            <div class="pop_title"></div>
            <div class="pop_info">
              感谢您对10/10的支持！您的会员卡型别不适用10/10 FRIENDS会员计划，故无法绑定。如有任何问题，点选菜单上的在线客服，谢谢。
            </div>
          </div>
        </div>
        <div class="pop_confirmBox" >
          <button class="confirm_no" @click="back">确定</button>
        </div>
      </section>
    </section>
  </div>
</template>

<script type="text/ecmascript-6">
    import store from  '../../utils/store.js';
    import JsBarcode from 'jsbarcode'
import '../../../public/static/js/transfer.js';
    // import '../../../public/static/js/vconsole.js';
  export default {
    data(){
      return{
            home:'',
            contactId:'',
            minutes: 5,
            seconds: 0,
            pointCount:'',//有效点数
            expirePoints:'',//到期点数
            contactName:'',//联系人姓名
            cardName:'',
            rankName:'',
            gold:false,
            platinum:false,
            friend:false,
            diamond:false,
            barcode:'',
            timer:null,
            records:3,
            inter:null,
            client:'',
            popshow:false,
            newtime:'',
            isType:'',
            isThirdError:'',
            isContact:'',
            clientHeight:''

      }
    },
    mounted () {
        this.add();
        // 获取浏览器可视区域高度
        this.clientHeight =  `${document.documentElement.clientHeight}`;
        console.log('clientHeight',this.clientHeight);
        // this.interval();
    },
    computed: {
        second: function () {
            return this.num(this.seconds);
        },
        minute: function () {
            return this.num(this.minutes);
        }
    },
    methods:{
        close(){
            this.popshow = false;
            wx.closeWindow();
            this.$forceUpdate();
        },
        back(){
            this.popshow = false;
            wx.closeWindow();
        },
        //千分位方法
        thousandth(str){
            if(str === '' || str === null){
                return str;
            }else{
                let re=/(?=(?!(\b))(\d{3})+$)/g;
                let str1 = str.toString();
                str1=str1.replace(re,",");
                return str1;
            }

        },
        getInfo(){
            let data = {
                openId: context.OpenId
            }
            this.config.server(
                "/Shop/Member/Info",
                "POST",
                data,
                (data)=> {
                    console.log('success',data);
                    if(data.records[0].isThirdError){
                        this.popshow = true;
                        this.isThirdError = data.records[0].isThirdError;
                        this.newtime = data.records[0].loctTime;
                        store.commit('add',['home','flag',false]);
                        let flag = store.state.home;
                        console.log('flag',flag);
                        return;
                    }else{
                        this.isThirdError = data.records[0].isThirdError;
                            if(data.records[0].isContact){
                                if(!data.records[0].isType){
                                    this.popshow = true;
                                    this.isType = data.records[0].isType;
                                    this.isContact = data.records[0].isContact;
                                    store.commit('add',['home','flag',false]);
                                    let flag = store.state.home;
                                    console.log('flag',flag);
                                    return;
                                }
                                this.home = true;
                                store.commit('add',['home','flag',true]);
                                let flag = store.state.home;
                                console.log('flag',flag);
                                this.contactId = data.records[0].contactId;
                                sessionStorage.setItem('contactId',this.contactId);
                                this.pointCount= this.thousandth(data.records[0].pointCount),//有效点数
                                    this.expirePoints= this.thousandth(data.records[0].expirePoints);//到期点数
                                this.contactName=data.records[0].contactName;//联系人姓名
                                this.getcode(data.records[0].barCode);
                                if(data.records[0].IdentityType === '00'){
                                    this.cardName='普卡';
                                    this.rankName = 'Friend';
                                    this.records = 1;
                                    this.friend = true;
                                }else if(data.records[0].IdentityType === '01'){
                                    this.cardName='金卡';
                                    this.rankName = 'Gold';
                                    this.records = 2;
                                    this.gold = true;
                                }else if(data.records[0].IdentityType === '02'){
                                    this.cardName='白金卡';
                                    this.rankName = 'Platinum';
                                    this.records = 3;
                                    this.platinum = true;
                                }else{
                                    this.cardName='钻石卡';
                                    this.rankName = 'Diamond';
                                    this.diamond = true;
                                    this.records = 4;
                                }
                                this.$forceUpdate();
                            }else{
                                    this.$router.replace('/phoneNum');
                                    sessionStorage.setItem('path','phoneNum');


                            }

                    }

                },
                (error)=> {
                    console.log('error',error);
                },
            )
        },
        //个人信息
        mycount(){
            let that = this;
            console.log('跳转页面的timer',that.timer);
            if(that.timer){
                clearInterval(that.timer);
                that.timer = null;
            }
            console.log(that.contactId);
            store.commit('setData',['myCount1','contactId',that.contactId]);
            this.$router.push('/myCount1');
        },
        //会员权益
        benefits(){
            let that = this;
            clearInterval(that.timer);
            that.timer = null;
            this.$router.push('/memberRights');
        },
        //消费明细
        expense(){
            let that = this;
            clearInterval(that.timer);
            that.timer = null;
            store.commit('setData',['expenseDetail','contactId',this.contactId]);
            this.$router.push('/expenseDetail');
        },
        //积分记录
        record(){
            let that = this;
            clearInterval(that.timer);
            that.timer = null;
            store.commit('setData',['integralRecord','contactId',this.contactId]);
            this.$router.push('/integralRecord');
        },
        //生成一维条形码
        getcode(barCode) {
            this.barcode = barCode;
            // this.$forceUpdate();
            JsBarcode("#barcode", barCode, {
                format: "CODE128",//选择要使用的条形码类型
                text: barCode,    //显示文本
                displayValue: true,//是否在条形码下方显示文字
                textPosition: "bottom",//设置文本的垂直位置
                // fontOptions: "bold italic",//使文字加粗体或变斜体
                background: "#fff",//设置条形码的背景
                font: "Noto Sans SC',sans-serif",//设置文本的字体
                lineColor: "#000",//设置条和文本的颜色。
                margin: 6,//设置条形码周围的空白边距
                height:45,
                width:1.5

            })
        },
        num: function (n) {
            return n < 10 ? '0' + n : '' +  n
            console.log('n',n);
        },
        add: function () {
            let that = this;
            that.timer = setInterval(function () {
                if (that.seconds === '0'+0 && that.minutes > 0) {
                    that.seconds = 59
                    that.minutes -= 1
                    if(that.minutes <10 ){
                        that.minutes = '0' + that.minutes;
                    }
                    console.log('分钟',that.minutes);
                    console.log('time1',that.timer);
                    // that.$forceUpdate();

                } else if (that.minutes === '0'+0 && that.seconds === '0' +0) {
                    // _this.seconds = 0+ '0';
                    console.log('定时器结束',that.timer);
                    that.seconds = '0' + 0;
                    that.minutes = 5;
                    clearInterval(that.timer);
                    that.timer = null;
                    that.getInfo();
                    that.add();

                } else {
                    that.seconds -= 1
                    if(that.seconds <10 ){
                        that.seconds = '0' + that.seconds;
                    }
                    console.log('秒',that.seconds);
                    // that.$forceUpdate();
                }
            }, 1000)
            console.log('time2',that.timer);
        }
    },
      // beforeDestroy(){  // 组件销毁前调用
      //     console.log('清除定时器');
      //     let that = this;
      //     console.log('time',that.time);
      //     clearInterval(this.time);
      //     this.time = null;
      // },
      //清除定时器
      destroyed(){
          let that = this;
          if(this.timer) { //如果定时器在运行则关闭
              clearInterval(this.timer);
          }
          this.timer = '';
      },
      created(){
          // this.add();
          // this.interval();
        this.getInfo();
        console.log('context',context);
        this.minutes = 5;
        this.seconds = '0'+0;
        this.pointCount='',//有效点数
        this.expirePoints='';//到期点数
        this.contactName='';//联系人姓名
        this.cardName='';//卡片中文名
        this.rankName = '';//卡片英文名
        this.gold=false;
        this.platinum=false;
        this.friend=false;
        this.diamond=false;
        this.contactId = '';
        this.barcode='';
        this.timer = null;
        this.records = 3;
        this.inter = null;
        this.client = window.screen.width;
        this.popshow = false;
        this.newtime = '';
        this.isContact = '';
        console.log('client',this.client);

    }
  }
</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" type="text/scss" scoped>
// @import '../../utils/css/style.css';
// @import '../../../public/static/css/style.sass';
 //import '../../../public/static/css/style.css';
.box{
  width:100%;
  height: 100%;
}
.home{
  width: 100%;
  height: 100%;
}
.pop_info{
  overflow: hidden;
}
.pop .pop_confirmBox button, .pop .pop_confirmBox a{
  width: 100%;
}
.pop_info p{
  line-height: 25px;
}
.pop_title{
  margin-bottom:0;
}
.active{
  padding-left: 16px;
  padding-top: 16px;
  padding-bottom: 16px;

}
  /*.mb_card{*/
    /*width: 100%;*/
  /*}*/
/*#__vconsole .vc-switch {*/
  /*padding: 0 !important;*/
  /*width: 20px;*/
  /*height: 20px;*/
  /*border-radius: 50% !important;*/
  /*background: #999 !important;*/
  /*opacity: 0.6;*/
  /*z-index: 2000000;*/
/*}*/



</style>
